/*
 * SPDX-License-Identifier: GPL-2.0
 * Copyright (c) 2023 MCST
 */

#ifndef _E2K_ASM_CPU_FEATURES_H
#define _E2K_ASM_CPU_FEATURES_H

#ifndef __ASSEMBLY__
enum {
	/* Hardware bugs */
	CPU_HWBUG_CLW,
	CPU_HWBUG_SPURIOUS_EXC_ILL_INSTR_ADDR,
	CPU_HWBUG_CANNOT_DO_DMA_IN_NEIGHBOUR_NODE,
	CPU_HWBUG_KERNEL_DATA_MONITOR,
	CPU_HWBUG_WRITE_MEMORY_BARRIER,
	CPU_HWBUG_BAD_RESET,
	CPU_HWBUG_BREAKPOINT_INSTR,
	CPU_HWBUG_E8C_WATCHDOG,
	CPU_HWBUG_IOMMU,
	CPU_HWBUG_WC_DAM,
	CPU_HWBUG_TRAP_CELLAR_S_F,
	CPU_HWBUG_SS,
	CPU_HWBUG_AAU_AALDV,
	CPU_HWBUG_LEVEL_EOI,
	CPU_HWBUG_FALSE_SS,
	CPU_HWBUG_SPURIOUS_EXC_DATA_DEBUG,
	CPU_HWBUG_TLB_FLUSH_L1D,
	CPU_HWBUG_GUEST_ASYNC_PM,
	CPU_HWBUG_C3_SYNC,
	CPU_HWBUG_INTERSECTING_L1_ACCESSES,
	CPU_HWBUG_L1I_STOPS_WORKING,
	CPU_HWBUG_CLW_STALE_L1_ENTRY,
	CPU_HWBUG_RAM_SELF_REFRESH,
	CPU_HWBUG_PIPELINE_FREEZE_MONITORS,
	CPU_HWBUG_C3_WAIT_MA_C,
	CPU_HWBUG_VIRT_SCLKM3_INTC,
	CPU_HWBUG_VIRT_PUSD_PSL,
	CPU_HWBUG_USD_ALIGNMENT,
	CPU_HWBUG_PREFETCH_EMPTY,
	CPU_HWBUG_VIRT_PSIZE_INTERCEPTION,
	CPU_NO_HWBUG_SOFT_WAIT,
	CPU_HWBUG_SOFT_WAIT_E8C2,
	CPU_HWBUG_C3,
	CPU_HWBUG_HRET_INTC_CU,
	CPU_HWBUG_IMGGPU_NOSNOOP_ALWAYS_ON,
	CPU_HWBUG_C3_CREDITS_L3,
	CPU_HWBUG_INTC_CR_WRITE,
	CPU_HWBUG_TAGGED_LDW,
	CPU_HWBUG_GIGANTIC_FLUSH,
	CPU_HWBUG_VIRT_TLU_IB,
	CPU_HWBUG_CANNOT_DO_DMA_THROUGH_LINKS_B_AND_C,
	CPU_HWBUG_SCLKM1_DIV,
	CPU_HWBUG_EXC_INSTR_DEBUG,
	CPU_HWBUG_EXC_DEBUG,
	CPU_HWBUG_SECONDARY_BUS_RESET,
	CPU_HWBUG_INTC_INSTR_PAGE_MISS,
	CPU_HWBUG_CODE_PLACEMENT,
	CPU_HWBUG_CLW_LOW_RESTORE,

	/* Features, not bugs */
	CPU_FEAT_WC_LEGACY_VGA,
	CPU_FEAT_EPIC,
	CPU_FEAT_TRAP_V5,
	CPU_FEAT_TRAP_V6,
	CPU_FEAT_QPREG,
	CPU_FEAT_HW_PREFETCHER_L2,
	CPU_FEAT_SEPARATE_TLU_CACHE,
	CPU_FEAT_FILLR,
	CPU_FEAT_FILLC,
	CPU_FEAT_SEP_VIRT_SPACE,
	CPU_FEAT_PAGE_TABLE_V6,
	CPU_FEAT_ISET_V5,
	CPU_FEAT_ISET_V6,
	CPU_FEAT_ISET_V7,
	CPU_FEAT_ISET_NOT_V7,

	/* Expected new hardware features */
	CPU_FEAT_GLOBAL_IRQ_MASK,

	NR_CPU_FEATURES
};
#endif

#endif
